//
// The epsilon test is passed when each db[j] is such that
//
//             |db*[j]| < EPS*(TAU + |b*[j]|)
//
// where b*[j] and db*[j] are the SCALED parameters and corrections,
// respectively.  this is the normal convergence test, when
// everything is well behaved.  to pass the test the above
// inequalilty must hold for every parameter, i.e. every
// value of j.  // we find EPS = 1.e-4 and TAU = 1.0 usually
// suitable.
//

#include "fit.h"
cdbl    EPS = 2.0e-4;
cdbl    TAU = 1.0;

int eps_test(dbl* b, dbl* db, dbl* sf, int npar)
{
    fail_pass k = pass;

    for (int j = 0 ; j < npar ; j++) {
        if (fabs( db[j] * sf[j]) >= EPS * (TAU + fabs(b[j] * sf[j])))
            k = fail;
    }
    return k;
}

