//
// prints a brief "help file" on the screen
//

#include "fit.h"

void prn_info(char** argv)
{
    prn_usage(argv);

    cerr <<
      "     A line of the datafile should contain x[i], y[i]\n"
      "     and optionally s[i].  The paramfile (which "
      "\033[1;32mMUST\033[0;m be\n"
      "     present) should contain the initial guesses for\n"
      "     the parameters.  See \"man fit\" for more information.\n"
      "\n";
#ifdef __GLIBC__
    cerr <<
      "  Options (may be in any order):\n"
      "    --help                         display this help message\n"
      "    --version                      print version number\n"
      "    --output \033[1;32mgoplot\033[0;m|"
      "\033[1;32mgnuplot\033[0;m|"
      "\033[1;32mgnups\033[0;m "
      " create an output file for graphing\n"
      "    --precision \033[1;32mn\033[0;m"
      "                  specify number of sig figs in output\n"
      "    --extend                       extends range of fitted curve\n"
      "    --sigma                        assume \"absolute\" "
      "sigmas in datafile\n"
      "    --quiet                        suppress intermediate output\n";
      cerr <<
      "\n  Single-letter options (try "
      << argv[0]
      << " -v) also exist.\n\n";
#else
    cerr <<
      " Options:\n\n"
      "   -h                      display this help message\n"
      "   -v                      print version number\n"
      "   -o \033[1;32mgoplot\033[0;m|"
      "\033[1;32mgnuplot\033[0:m|"
      "\033[1;32mgnups\033[0;m "
      "create an output file for graphing\n"
      "   -p \033[1;32mn\033[0;m"
      "                    specify number of sig figs in output\n"
      "   -e                      extends range of fitted curve\n"
      "   -s                      assume \"absolute\" "
      "sigmas in datafile\n"
      "   -q                      suppress intermediate output\n\n";
#endif
}
