//
// scales g and a using scale factors sf equal
// to the square roots of the diagonal elements
//

#include "fit.h"

void scale(dbl** a, dbl* g, dbl* sf, int npar)
{
    dbl prod;
    int j, k;

// scale g

    for (j = 0 ; j < npar ; j++)
        if (a[j][j] > 0.0) {
            sf[j] = sqrt(a[j][j]);
            g[j] /= sf[j];
        }
        else {
            sf[j] = 0.0;
            g[j] = 0.0;
        }

// scale a

    for (j = 0 ; j < npar ; j++) {
        for (k = 0 ; k < j ; k++) {
            prod = sf[j] * sf[k];
            if (prod > 0.0)
                a[j][k] /= prod;
            else
                a[j][k] = 0.0;
            a[k][j] = a[j][k];
        }
        a[j][j] = 1.0;
    }
}

