//
// this is utils.h
//

#include "errors.h"
#include <sstream> // for g++ version >= 2.95.3
// #include <strstream>  // for g++ version <= 2.95.3
#include <iomanip>
#include <ctime>
#include <cstdlib>
#include <cmath>

#define gassert(expr) ggassert(#expr, __LINE__,\
    __FILE__, __PRETTY_FUNCTION__, expr)

using namespace std;

typedef    const char       cchr;
typedef    const int        cint;
typedef    double            dbl;
typedef    const double     cdbl;
typedef    unsigned const  ucint;

class array {                       // various array operations
public:
            array();
    dbl**   alloc_d(int r, int c);  // mem for matrix of dbls
    dbl*    alloc_d(int n );        // mem for vector of dbls
    int**   alloc_i(int r, int c);  // mem for matrix of ints
    int*    alloc_i(int n );        // mem for vector of ints
    void    dele(dbl**);            // delete matrix of dbls
    void    dele(dbl*);             // delete vector of dbls
    void    dele(int**);            // delete matrix of ints
    void    dele(int*);             // delete vector of ints
    void    fill_mat(dbl** mp);     // fills matrix with randoms
    void    fill_vec(dbl* vp);      // fills vector with randoms
    void    pr_mat(string, dbl**, int, int, int, ostream&); // print matrix
    void    pr_sym_mat(string, dbl**, int, int, ostream&);  // print sym matrix
    void    pr_vec(string, dbl*, int, int, ostream&);       // print vector
    void    set_elems(int n);       // sets elems = n

private:
    dbl**    md;
    dbl*     vd;
    int**    mi;
    int*     vi;
    int    rows;
    int    cols;
    int   elems;
};
void operator<<(ostream& os, array a);

void grewind(istream& is);
void ggassert(cchr*, int, cchr*, cchr*, bool);
float lnfac(int);
float lngam(float);
void gser(dbl*, dbl, dbl, dbl*);
void gcf(dbl*, dbl, dbl, dbl*);
dbl gammq(dbl, dbl);
